#ifndef __ZX_LED_H__
#define __ZX_LED_H__

#include "driver.h"
#include "device.h"
#include "driver/gpio.h"

class ZX_LED : public Device {
	private:
		enum {
			s_detect, s_idle
		} state;
		gpio_num_t gpio_num;
		int status;

	public:
		TickType_t tickcnt;
		// constructor
		ZX_LED(gpio_num_t gpio);

		// override
		void init(void);
		void process(Driver *drv);
		int prop_count(void);
		bool prop_name(int index, char *name);
		bool prop_unit(int index, char *unit);
		bool prop_attr(int index, char *attr);
		bool prop_read(int index, char *value);
		bool prop_write(int index, char *value);
		// method
		void out(int stat);
};

#endif
